package com.jevon.service.impl;

import com.jevon.mapper.TeacherClassMapper;
import com.jevon.model.TeacherClass;
import com.jevon.service.TeacherClassService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/9/29 0029 11:31
 */
@Service("teacherClassService")
public class TeacherClassServiceImpl implements TeacherClassService {

    @Autowired
    TeacherClassMapper teacherClassMapper;

    @Override
    public int insert(TeacherClass teacherClass) {
        return teacherClassMapper.insert(teacherClass);
    }

    @Override
    public int insertBatch(List<TeacherClass> teacherClasses) {
        int i = 0 ;
        List<TeacherClass> result = new ArrayList<>();
        for(TeacherClass teacherClass :teacherClasses){
            i++ ;
            result.add(teacherClass);
            if(i % 100 == 0){
                teacherClassMapper.insertBatch(result);
                result = new ArrayList<>();
            }
        }
        teacherClassMapper.insertBatch(result);
        return 1;
    }

    @Override
    public List<TeacherClass> selectByCourseName(TeacherClass teacherClass) {
        return teacherClassMapper.selectByCourseName(teacherClass);
    }

    @Override
    public TeacherClass selectByTeacher(TeacherClass teacherClass) {
        return teacherClassMapper.selectByTeacher(teacherClass);
    }

    @Override
    public TeacherClass selectByCourseAndClass(TeacherClass teacherClass) {
        return teacherClassMapper.selectByCourseAndClass(teacherClass);
    }

    @Override
    public List<TeacherClass> selectBySchoolAndTeam(TeacherClass teacherClass) {
        return teacherClassMapper.selectBySchoolAndTeam(teacherClass);
    }

    @Override
    public int deleteBySchoolAndTeam(TeacherClass teacherClass) {
        return teacherClassMapper.deleteBySchoolAndTeam(teacherClass);
    }

    @Override
    public TeacherClass selectById(int tClassId) {
        return teacherClassMapper.selectById(tClassId);
    }

    @Override
    public int updateSchedule(int tClassId) {
        return teacherClassMapper.updateSchedule(tClassId);
    }

    @Override
    public int selectHasSchedule(int schoolId, String team) {
        TeacherClass teacherClass = new TeacherClass();
        teacherClass.setSchoolId(schoolId);
        teacherClass.setTeam(team);
        return teacherClassMapper.selectHasSchedule(teacherClass);
    }

    @Override
    public int recallTeacherClass(int tClassId) {
        return teacherClassMapper.recallTeacherClass(tClassId);
    }
}
